MRuby::Build.new do |conf|
  # load specific toolchain settings

  # Gets set by the VS command prompts.
  if ENV['VisualStudioVersion']
    toolchain :visualcpp
  else
    toolchain :gcc
  end

  enable_debug

  # Use mrbgems
  # conf.gem 'examples/mrbgems/ruby_extension_example'
  # conf.gem 'examples/mrbgems/c_extension_example' do |g|
  #   g.cc.flags << '-g' # append cflags in this gem
  # end
  # conf.gem 'examples/mrbgems/c_and_ruby_extension_example'
  # conf.gem :github => 'masuidrive/mrbgems-example', :branch => 'master'
  # conf.gem :git => 'git@github.com:masuidrive/mrbgems-example.git', :branch => 'master', :options => '-v'

  # include the default GEMs
  conf.gembox 'default'

  # C compiler settings
  # conf.cc do |cc|
  #   cc.command = ENV['CC'] || 'gcc'
  #   cc.flags = [ENV['CFLAGS'] || %w()]
  #   cc.include_paths = ["#{root}/include"]
  #   cc.defines = %w(DISABLE_GEMS)
  #   cc.option_include_path = '-I%s'
  #   cc.option_define = '-D%s'
  #   cc.compile_options = "%{flags} -MMD -o %{outfile} -c %{infile}"
  # end

  # mrbc settings
  # conf.mrbc do |mrbc|
  #   mrbc.compile_options = "-g -B%{funcname} -o-" # The -g option is required for line numbers
  # end

  # Linker settings
  # conf.linker do |linker|
  #   linker.command = ENV['LD'] || 'gcc'
  #   linker.flags = [ENV['LDFLAGS'] || []]
  #   linker.flags_before_libraries = []
  #   linker.libraries = %w()
  #   linker.flags_after_libraries = []
  #   linker.library_paths = []
  #   linker.option_library = '-l%s'
  #   linker.option_library_path = '-L%s'
  #   linker.link_options = "%{flags} -o %{outfile} %{objs} %{libs}"
  # end

  # Archiver settings
  # conf.archiver do |archiver|
  #   archiver.command = ENV['AR'] || 'ar'
  #   archiver.archive_options = 'rs %{outfile} %{objs}'
  # end

  # Parser generator settings
  # conf.yacc do |yacc|
  #   yacc.command = ENV['YACC'] || 'bison'
  #   yacc.compile_options = '-o %{outfile} %{infile}'
  # end

  # gperf settings
  # conf.gperf do |gperf|
  #   gperf.command = 'gperf'
  #   gperf.compile_options = '-L ANSI-C -C -p -j1 -i 1 -g -o -t -N mrb_reserved_word -k"1,3,$" %{infile} > %{outfile}'
  # end

  # file extensions
  # conf.exts do |exts|
  #   exts.object = '.o'
  #   exts.executable = '' # '.exe' if Windows
  #   exts.library = '.a'
  # end

  # file separetor
  # conf.file_separator = '/'

  # bintest
  # conf.enable_bintest = true
end

# Define cross build settings
MRuby::CrossBuild.new('pcat') do |conf|

  toolchain :gcc

  # C compiler settings
  conf.cc do |cc|
    cc.command = "#{ENV['GNUi386']}/bin/gcc386"
    cc.flags = "-O2 -fno-strength-reduce -mpreferred-stack-boundary=2 -Wall"
    cc.include_paths = ["#{root}/include", "../src/posix_include", "#{ENV['BD']}/include"]
    cc.defines = %w(MRB_DISABLE_STDIO PCAT)
  end

  # Linker settings
  conf.linker do |linker|
    linker.command = "#{ENV['GNUi386']}/bin/gcc386"
    linker.flags = [ENV['LDFLAGS'] || []]
    linker.flags_before_libraries = []
    linker.libraries = %w(img  app tf gcc main_r dbg lang g sys g f svc)
    linker.flags_after_libraries = []
    linker.library_paths = ["#{ENV['BD']}/lib/i386e2"]
    linker.option_library = '-l%s'
    linker.option_library_path = '-L%s'
    linker.link_options = "%{flags} -o %{outfile} %{objs} %{libs}"
  end
  
  # Archiver settings
  conf.archiver do |archiver|
    archiver.command = "#{ENV['GNUi386']}/bin/ar"
    archiver.archive_options = 'rvl %{outfile} %{objs}'
  end

  @bins = [] # for disable to link mrbc for target.

  conf.gem 'mrbgems_port/mruby-brightv-posixwrapper'
  conf.gem 'mrbgems_port/mruby-brightv-print'
  conf.gem 'mruby/mrbgems/mruby-compiler'
  conf.gem 'mrbgems_port/mruby-test'
#
#   conf.test_runner.command = 'env'
#
end
